User interaction in EJ2 JavaScript Signature control

15 May 20239 minutes to read

The below interactions were available in Signature, and we can walk through one by one.

  • Undo and Redo
  • Clear
  • Disabled
  • ReadOnly

Undo and Redo

In the Signature, every action can be maintained as a snap for undo and redo operations. And maintained SnapIndex for indexing the snap collection.

The undo method reverts the last action of signature by decreasing SnapIndex value to index previous snap. Here, canUndo method is used to ensure whether undo can be performed or not.

The redo method reverts the last undo action of the signature by increasing the SnapIndex to get the next snap. Here, canRedo method is used to ensure whether redo can be performed or not.

Clear

The clear method is used to clears the signature and makes the canvas empty. This is also considered in Undo/ Redo. Here, isEmpty method is used to ensure whether the signature is empty or not.

Disabled

The disabled property is used to enables/disables the signature control. In the disabled state, the user is not allowed to draw signature. And it can’t be focused until the user enabled the signature.

ReadOnly

The isReadOnly property is used to enables/disables the ReadOnly Signature. It can be focused but it prevents drawing in Signature.

The following sample explains about user interactions available in signature.

ej.base.enableRipple = true;

var signature = new ej.inputs.Signature({change: changeEvent}, '#signature');

var undoButton = new ej.buttons.Button({cssClass: 'e-primary', disabled: true}, '#undo');
undoButton.element.onclick = function (e) {
    if (!signature.disabled && !signature.isReadOnly) {
        signature.undo();
    }
};

var redoButton = new ej.buttons.Button({cssClass: 'e-primary', disabled: true}, '#redo');
redoButton.element.onclick = function (e) {
    if (!signature.disabled && !signature.isReadOnly) {
        signature.redo();   
    }
};

var clearButton = new ej.buttons.Button({cssClass: 'e-primary', disabled: true}, '#clear');
clearButton.element.onclick = function (e) {
    if (!signature.disabled && !signature.isReadOnly) {
        signature.clear();   
    }
};

var checkBox1 = new ej.buttons.CheckBox({ label: 'Disabled', change: onChangeDisable}, '#disable');
function onChangeDisable(args) {
    signature.disabled = args.checked;
}

var checkBox2 = new ej.buttons.CheckBox({ label: 'ReadOnly', change: onChangeReadonly}, '#readonly');
function onChangeReadonly(args) {
    signature.isReadOnly = args.checked;
}

function changeEvent(args) {
    if (!signature.disabled && !signature.isReadOnly) {
        if (signature.canUndo()) {
            undoButton.disabled = false;
        } else {
            undoButton.disabled = true;
        }
        if (signature.canRedo()) {
            redoButton.disabled = false;
        } else {
            redoButton.disabled = true;
        }
        if (!signature.isEmpty()) {
            clearButton.disabled = false;
        } else {
            clearButton.disabled = true;
        }
    }
}
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Signature</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="TypeScript Signature Component">
    <meta name="author" content="Syncfusion">
    <link href="styles.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/25.1.35/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/25.1.35/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/25.1.35/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/25.1.35/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/25.1.35/ej2-dropdowns/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/25.1.35/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/25.1.35/ej2-popups/styles/material.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/25.1.35/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="option">
            <table>
                <tbody><tr>
                    <td>
                        <button id="undo" style="margin-right: 20px;">UNDO</button>
                    </td><td>
                        <button id="redo" style="margin-right: 20px;">REDO</button>
                    </td><td>
                        <button id="clear" style="margin-right: 200px;">CLEAR</button>
                    </td><td>
                        <div style="margin-bottom: 5px;"><input id="disable" type="checkbox"></div>
                        <div><input id="readonly" type="checkbox"></div>
                    </td>
                </tr>
            </tbody></table>
        </div>
        <div id="signature-control">
            <canvas id="signature" style="height: 100%; width: 100%;"></canvas>
        </div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>
#container {
  visibility: hidden;
}

#loader {
  color: #008cff;
  font-family: 'Helvetica Neue','calibiri';
  font-size: 14px;
  height: 40px;
  left: 45%;
  position: absolute;
  top: 45%;
  width: 30%;
}

#signature-control {
  height: 300px;
  width: 550px;
}

#signature {
  border: 1px solid lightgray;
}

#option {
  margin-bottom: 10px;
}

User interaction in Vue Signature component

16 Mar 20238 minutes to read

The below interactions were available in Signature, and we can walk through one by one.

  • Undo and Redo
  • Clear
  • Disabled
  • ReadOnly

Undo and Redo

In the Signature, every action can be maintained as a snap for undo and redo operations. And maintained SnapIndex for indexing the snap collection.

The undo method reverts the last action of signature by decreasing SnapIndex value to index previous snap. Here, canUndo method is used to ensure whether undo can be performed or not.

The redo method reverts the last undo action of the signature by increasing the SnapIndex to get the next snap. Here, canRedo method is used to ensure whether redo can be performed or not.

Clear

The clear method is used to clears the signature and makes the canvas empty. This is also considered in Undo/ Redo. Here, isEmpty method is used to ensure whether the signature is empty or not.

Disabled

The disabled property is used to enables/disables the signature component. In the disabled state, the user is not allowed to draw signature. And it can’t be focused until the user enabled the signature.

ReadOnly

The isReadOnly property is used to enables/disables the ReadOnly Signature. It can be focused but it prevents drawing in Signature.

The following sample explains about user interactions available in signature.

<template>
<div class='wrap'>
    <div id="option">
            <table>
                <tr>
                    <td>
                       <ejs-button id="undo" cssClass="e-primary" :disabled="undoDisable" v-on:click.native="onUndo">UNDO</ejs-button>
                    </td><td>
                        <ejs-button id="redo" cssClass="e-primary" :disabled="redoDisable" v-on:click.native="onRedo">REDO</ejs-button>
                    </td><td>
                        <ejs-button id="clear" cssClass="e-primary" :disabled="clearDisable" v-on:click.native="onClear">CLEAR</ejs-button>
                    </td><td>
                        <div style="margin-bottom: 5px; margin-left: 200px;"><ejs-checkbox label='Disabled' :change="disableChange"></ejs-checkbox></div>
                        <div style="margin-left: 200px;"><ejs-checkbox label='ReadOnly' :change="readOnlyChange"></ejs-checkbox></div>
                    </td>
                </tr>
            </table>
        </div>
        <div id ="signature-control">
            <ejs-signature id="signature" :change="onChange"></ejs-signature>
        </div>
</div>
</template>

<script>
import Vue from 'vue';
import { SignaturePlugin } from "@syncfusion/ej2-vue-inputs";
import { ButtonPlugin } from '@syncfusion/ej2-vue-buttons';
import { getComponent } from '@syncfusion/ej2-base';
import { CheckBoxPlugin } from "@syncfusion/ej2-vue-buttons";
import { enableRipple } from '@syncfusion/ej2-base';

enableRipple(true);
Vue.use(CheckBoxPlugin);
Vue.use(SignaturePlugin);
Vue.use(ButtonPlugin);

export default {
   data: function() {
    return {
      undoDisable: true, redoDisable: true, clearDisable: true,
    };
  },
  methods: {
    onUndo: function(args) {
        var signature = getComponent(document.getElementById('signature'), 'signature');
        if (!signature.disabled && !signature.isReadOnly) {
          signature.undo();
        }
    },
    onRedo: function(args) {
      var signature = getComponent(document.getElementById('signature'), 'signature');
        if (!signature.disabled && !signature.isReadOnly) {
          signature.redo();
        }
    },
    onClear: function(args) {
      var signature = getComponent(document.getElementById('signature'), 'signature');
        if (!signature.disabled && !signature.isReadOnly) {
          signature.clear();
        }
    },
    disableChange: function(args) {
      var signature = getComponent(document.getElementById('signature'), 'signature');
      signature.disabled = args.checked;
    },
    readOnlyChange: function(args) {
      var signature = getComponent(document.getElementById('signature'), 'signature');
      signature.isReadOnly = args.checked;
    },
    onChange: function() {
      var signature = getComponent(document.getElementById('signature'), 'signature');
      if (!signature.disabled && !signature.isReadOnly) {
        if (signature.canUndo()) {
            this.undoDisable = false;
        } else {
            this.undoDisable = true;
        }
        if (signature.canRedo()) {
            this.redoDisable = false;
        } else {
            this.redoDisable = true;
        }
        if (!signature.isEmpty()) {
            this.clearDisable = false;
        } else {
            this.clearDisable = true;
        }
    }
    }
  }
}
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-dropdowns/styles/material.css";

#signature {
  border: 1px solid lightgray;
  height: 100%;
  width: 100%;
}

#signature-control {
  height: 300px;
  width: 550px;
}

#option {
  margin-bottom: 10px;
}

.wrap {
    height: 300px;
    width: 100%;
}
</style>

User interaction in React Signature component

30 Jan 202316 minutes to read

The below interactions were available in Signature, and we can walk through one by one.

  • Undo and Redo
  • Clear
  • Disabled
  • ReadOnly

Undo and Redo

In the Signature, every action can be maintained as a snap for undo and redo operations. And maintained SnapIndex for indexing the snap collection.

The undo method reverts the last action of signature by decreasing SnapIndex value to index previous snap. Here, canUndo method is used to ensure whether undo can be performed or not.

The redo method reverts the last undo action of the signature by increasing the SnapIndex to get the next snap. Here, canRedo method is used to ensure whether redo can be performed or not.

Clear

The clear method is used to clears the signature and makes the canvas empty. This is also considered in Undo/ Redo. Here, isEmpty method is used to ensure whether the signature is empty or not.

Disabled

The disabled property is used to enables/disables the signature component. In the disabled state, the user is not allowed to draw signature. And it can’t be focused until the user enabled the signature.

ReadOnly

The isReadOnly property is used to enables/disables the ReadOnly Signature. It can be focused but it prevents drawing in Signature.

The following sample explains about user interactions available in signature.

import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { SignatureComponent } from '@syncfusion/ej2-react-inputs';
import { ButtonComponent, CheckBoxComponent } from '@syncfusion/ej2-react-buttons';
import { getComponent } from '@syncfusion/ej2-base';
function App() {
    function undoBtnCreated() {
        document.getElementById('undo').addEventListener('click', undoBtnClick);
    }
    function undoBtnClick() {
        let signature = getComponent(document.getElementById('signature'), 'signature');
        if (!signature.disabled && !signature.isReadOnly) {
            signature.undo();
        }
    }
    function redoBtnCreated() {
        document.getElementById('redo').addEventListener('click', redoBtnClick);
    }
    function redoBtnClick() {
        let signature = getComponent(document.getElementById('signature'), 'signature');
        if (!signature.disabled && !signature.isReadOnly) {
            signature.redo();
        }
    }
    function clrBtnCreated() {
        document.getElementById('clear').addEventListener('click', clrBtnClick);
    }
    function clrBtnClick() {
        let signature = getComponent(document.getElementById('signature'), 'signature');
        if (!signature.disabled && !signature.isReadOnly) {
            signature.clear();
        }
    }
    function disableChange(args) {
        let signature = getComponent(document.getElementById('signature'), 'signature');
        signature.disabled = args.checked;
    }
    function readOnlyChange(args) {
        let signature = getComponent(document.getElementById('signature'), 'signature');
        signature.isReadOnly = args.checked;
    }
    function change(args) {
        let signature = getComponent(document.getElementById('signature'), 'signature');
        let undoButton = getComponent(document.getElementById('undo'), 'btn');
        let redoButton = getComponent(document.getElementById('redo'), 'btn');
        let clearButton = getComponent(document.getElementById('clear'), 'btn');
        if (!signature.disabled && !signature.isReadOnly) {
            if (signature.canUndo()) {
                undoButton.disabled = false;
            }
            else {
                undoButton.disabled = true;
            }
            if (signature.canRedo()) {
                redoButton.disabled = false;
            }
            else {
                redoButton.disabled = true;
            }
            if (!signature.isEmpty()) {
                clearButton.disabled = false;
            }
            else {
                clearButton.disabled = true;
            }
        }
    }
    return (<div id='container'>
      <div id="option">
          <table>
              <tr>
                  <td>
                    <ButtonComponent id='undo' cssClass='e-primary' content='UNDO' disabled={true} created={undoBtnCreated.bind(this)}/>
                  </td><td>
                    <ButtonComponent id='redo' cssClass='e-primary' content='REDO' disabled={true} created={redoBtnCreated.bind(this)}/>
                  </td><td>
                    <ButtonComponent id='clear' cssClass='e-primary' content='CLEAR' disabled={true} created={clrBtnCreated.bind(this)}/>
                  </td><td>
                      <div id="checkbox1">
                        <CheckBoxComponent label="Disabled" change={disableChange}/>
                      </div>
                      <div id="checkbox2"><CheckBoxComponent label="ReadOnly" change={readOnlyChange}/></div>
                  </td>
              </tr>
          </table>
      </div>
      <div id="signature-control">
          <SignatureComponent id='signature' change={change}/>
      </div>
  </div>);
}
;
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { SignatureFileType, Signature, SignatureComponent, SignatureChangeEventArgs } from '@syncfusion/ej2-react-inputs';
import { ButtonComponent, CheckBoxComponent } from '@syncfusion/ej2-react-buttons';
import { getComponent, closest } from '@syncfusion/ej2-base';
import { ChangeEventArgs, CheckBox } from '@syncfusion/ej2-buttons';

function App() {
  function undoBtnCreated() {
    document.getElementById('undo').addEventListener('click', undoBtnClick);
  }
  function undoBtnClick() {
    let signature: Signature = getComponent(document.getElementById('signature'), 'signature');
    if (!signature.disabled && !signature.isReadOnly) {
      signature.undo();
    }
  }
  function redoBtnCreated() {
    document.getElementById('redo').addEventListener('click', redoBtnClick);
  }
  function redoBtnClick() {
    let signature: Signature = getComponent(document.getElementById('signature'), 'signature');
    if (!signature.disabled && !signature.isReadOnly) {
      signature.redo();
    }
  }
  function clrBtnCreated() {
    document.getElementById('clear').addEventListener('click', clrBtnClick);
  }
  function clrBtnClick() {
    let signature: Signature = getComponent(document.getElementById('signature'), 'signature');
    if (!signature.disabled && !signature.isReadOnly) {
      signature.clear();
    }
  }
  function disableChange(args: ChangeEventArgs) {
    let signature: Signature = getComponent(document.getElementById('signature'), 'signature');
    signature.disabled = args.checked;
  }
  function readOnlyChange(args: ChangeEventArgs) {
    let signature: Signature = getComponent(document.getElementById('signature'), 'signature');
    signature.isReadOnly = args.checked;
  }
  function change(args: SignatureChangeEventArgs) {
    let signature: Signature = getComponent(document.getElementById('signature'), 'signature');
    let undoButton: Button = getComponent(document.getElementById('undo'), 'btn');
    let redoButton: Button = getComponent(document.getElementById('redo'), 'btn');
    let clearButton: Button = getComponent(document.getElementById('clear'), 'btn');
    if (!signature.disabled && !signature.isReadOnly) {
        if (signature.canUndo()) {
            undoButton.disabled = false;
        } else {
            undoButton.disabled = true;
        }
        if (signature.canRedo()) {
            redoButton.disabled = false;
        } else {
            redoButton.disabled = true;
        }
        if (!signature.isEmpty()) {
            clearButton.disabled = false;
        } else {
            clearButton.disabled = true;
        }
    }
  }
  return (<div id='container'>
      <div id="option">
          <table>
              <tr>
                  <td>
                    <ButtonComponent id='undo' cssClass='e-primary' content='UNDO' disabled={true} created={undoBtnCreated.bind(this)}/>
                  </td><td>
                    <ButtonComponent id='redo' cssClass='e-primary' content='REDO' disabled={true} created={redoBtnCreated.bind(this)}/>
                  </td><td>
                    <ButtonComponent  id='clear' cssClass='e-primary' content='CLEAR' disabled={true} created={clrBtnCreated.bind(this)}/>
                  </td><td>
                      <div id="checkbox1">
                        <CheckBoxComponent label="Disabled" change={disableChange}/>
                      </div>
                      <div id="checkbox2"><CheckBoxComponent label="ReadOnly" change={readOnlyChange}/></div>
                  </td>
              </tr>
          </table>
      </div>
      <div id ="signature-control">
          <SignatureComponent id='signature' change={change}/>
      </div>
  </div>
  )
};
export default App;
ReactDOM.render(<App />, document.getElementById('element'));

User interaction in Angular Signature component

28 Sep 20238 minutes to read

The below interactions were available in Signature, and we can walk through one by one.

  • Undo and Redo
  • Clear
  • Disabled
  • ReadOnly

Undo

In the Signature, every action can be maintained as a snap for undo and redo operations. And maintained SnapIndex for indexing the snap collection.

The undo method reverts the last action of signature by decreasing SnapIndex value to index previous snap. Here, canUndo method is used to ensure whether undo can be performed or not.

The redo method reverts the last undo action of the signature by increasing the SnapIndex to get the next snap. Here, canRedo method is used to ensure whether redo can be performed or not.

Clear

The clear method is used to clears the signature and makes the canvas empty. This is also considered in Undo/ Redo. Here, isEmpty method is used to ensure whether the signature is empty or not.

Disabled

The disabled property is used to enables/disables the signature component. In the disabled state, the user is not allowed to draw signature. And it can’t be focused until the user enabled the signature.

ReadOnly

The isReadOnly property is used to enables/disables the ReadOnly Signature. It can be focused but it prevents drawing in Signature.

The following sample explains about user interactions available in signature.

User Integration sample

import { Component, ViewChild } from '@angular/core';
import { enableRipple } from '@syncfusion/ej2-base';
import { SignatureComponent } from '@syncfusion/ej2-angular-inputs';
import { Button, ChangeEventArgs } from '@syncfusion/ej2-buttons';
import { getComponent } from '@syncfusion/ej2-base';

enableRipple(true);

@Component({
    selector: 'app-root',
    template: `<div class="e-section-control">
            <div id="option">
            <table>
                <tr>
                    <td>
                        <button ejs-button id="undo" #undo cssClass="e-primary" (click)="onUndo()" disabled={true}>UNDO</button>
                    </td><td>
                        <button ejs-button id="redo" #redo cssClass="e-primary" (click)="onRedo()" disabled={true}>REDO</button>
                    </td><td>
                        <button ejs-button id="clear" #clear cssClass="e-primary" (click)="onClear()" disabled={true}>CLEAR</button>
                    </td><td>
                        <div id="checkbox1"><ejs-checkbox label="Disable" (change)="onDisableChange($event)"></ejs-checkbox></div>
                        <div id="checkbox1"><ejs-checkbox label="ReadOnly" (change)="onReadOnlyChange($event)"></ejs-checkbox></div>
                    </td>
                </tr>
            </table>
        </div>
        <div id ="signature-control">
           <canvas ejs-signature #signature id="signature" (change)="change()"></canvas>
        </div>
        </div>`
})
export class AppComponent {
    @ViewChild('signature')
    public signature?: SignatureComponent;
    onUndo(): void {
        if (!this.signature.disabled && !this.signature.isReadOnly) {
            this.signature.undo();
        }
    }
    onRedo(): void {
        if (!this.signature.disabled && !this.signature.isReadOnly) {
            this.signature.redo();
        }
    }
    onClear(): void {
        if (!this.signature.disabled && !this.signature.isReadOnly) {
            this.signature.clear();
        }
    }
    onDisableChange(args: ChangeEventArgs): void {
        this.signature.disabled = args.checked;
    }
    onReadOnlyChange(args: ChangeEventArgs): void {
        this.signature.isReadOnly = args.checked;
    }
    change(): void {
        let undoButton: Button = getComponent(document.getElementById("undo"), 'btn');
        let redoButton: Button = getComponent(document.getElementById("redo"), 'btn');
        let clearButton: Button = getComponent(document.getElementById("clear"), 'btn');
        if (!this.signature.disabled && !this.signature.isReadOnly) {
            if (this.signature.canUndo()) {
                undoButton.disabled = false;
            } else {
                undoButton.disabled = true;
            }
            if (this.signature.canRedo()) {
                redoButton.disabled = false;
            } else {
                redoButton.disabled = true;
            }
            if (!this.signature.isEmpty()) {
                clearButton.disabled = false;
            } else {
                clearButton.disabled = true;
            }
        }
    }
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { AppComponent } from './app.component';
import { SignatureComponent } from '@syncfusion/ej2-angular-inputs';
import { CheckBoxModule } from '@syncfusion/ej2-angular-buttons';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';
import { enableRipple } from '@syncfusion/ej2-base';

enableRipple(true);

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule,FormsModule,CheckBoxModule,ButtonModule
    ],
    declarations: [AppComponent, SignatureComponent],
    bootstrap: [AppComponent]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

import 'zone.js';
enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);